
class Lib {
	constructor(arg) {
		this.$this = arg._this
		this.stage = arg.stage
	}
	
	calculate(option) {
		let objW = option.element.width || 1080 //目标对象
		let objH = option.element.height || 1920
		const mw = window.innerWidth //屏幕对象
		const mh = window.innerHeight
		let sw = option.Stage.width || mw //舞台对象
		let sh = option.Stage.height || window.innerHeight

		console.log('cs');
	}
	
	request(option,callback,complete = ()=>{}){
		if(!option.url){
			console.error('请传入模块');
			rej({msg:'请传入模块'})
			complete({msg:'请传入模块'})
			return;
		}
		let Token = $.cookie('Token')
		if(!option.option){
			option.option = {}
			option.option.data = {}
		}
		return new Promise((res,rej)=>{
			$.ajax({
				type:"POST", 
				url: http + option.url, 
				dataType:"json", 
				headers: {
				    'Version-Number': option.option.data.version || 1,
				    "Timestamp": timeDispose(option.option.data.timestamp || new Date()),
					"Db-Token": Token,
				    "Secret": _md5({
						...option.data,
						openid:$.cookie('openid') || ''
					}),
				},
				data:{
					...option.data,
					openid:$.cookie('openid') || ''
				}, 
				success:function(result){
					console.log(result)
					if(result.code == -1){
						if(result.msg === 'token失效'){
							alert('登录过期')
						}else{
							alert(result.msg)
						}
						complete(result)
						rej(result)
					}else{
						complete(result)
						callback(result)
						res(result)
					}
					complete(result)
				}, 
				error:function(err){ 
					complete(err)
					rej(err)
				} 
			})
		})
	}
	
	loadText(option,layer,callback = ()=>{}){
		// console.log('文本开始中star');
		if(!option || !layer){
			console.log('loadText 参数错误');
			return;
		}
		option.type = 'text'
		let textNode = new Konva.Text(option);
		textNode.attrs.fontStyle = textNode.fontStyle()
		textNode.attrs.fontFamily = textNode.fontFamily()
		textNode.attrs.rotation = textNode.rotation()
		textNode.attrs.scaleY = textNode.scaleY()
		textNode.attrs.scaleX = textNode.scaleX()
		textNode.attrs.textDecoration = textNode.textDecoration()
		textNode.attrs.align = textNode.align()
		textNode.attrs.lineHeight = textNode.lineHeight()
		textNode.attrs.letterSpacing = textNode.letterSpacing()
		console.log(textNode);
		const _this = this.$this
		let tr = null;
		let isToHistory = false
		if(_this.posterList[option.tempIndex]){
			_this.posterList[option.tempIndex].fontFamily = textNode.fontFamily()
		}
		layer.add(textNode);
		if(option.isDraggable){
			textNode.hitFunc(function(context) {
			  context.beginPath();
			  context.rect(0, 0, textNode.width(), textNode.height());
			  context.closePath();
			  context.fillStrokeShape(textNode);
			});
		}else{
			console.log('绘画禁止点击区域: '+option.id);
			textNode.hitFunc(function(context) {
			  context.beginPath();
			  context.rect(0, 0, 0, 0);
			  context.closePath();
			  context.fillStrokeShape(textNode);
			});
		}
		if(option.frame){
			tr = addFrame({
				current:textNode,
				anchorSize:20,
				keepRatio:false,
				rotationSnaps:[0, 90, 180, 270],
				...option.frame,
				padding:_this.isAdmin?0:5,
				widthMin:option.widthMin?option.widthMin:option.fontSize+~~option.frame.padding*2,
				type:'text',
			},_this)
			textNode.on('tap click',(e)=>{
				e.cancelBubble = true ;
				if(_this.curId == textNode.getId()){
					if(_this.curEditType === 3){
						_this.editTextType = 1
						_this.curHanleType = 'text'
						console.log(textNode.position())
						let positionY = _this.stageYWatch + textNode.position().y
						console.log('Y:'+positionY);
						if((_this.height /3)<positionY){
							console.log('需要移动');
							let numY = positionY - (_this.height /3)
							_this.stageOffsetY = -(positionY - numY)
							console.log(_this.stageOffsetY);
						}else{
							console.log('不需要移动');
						}
					}
					_this.handleControl('editText',{item:textNode,index:option.id})
					if(_this.isAdmin){
						textNode.fire('editText')
					}else{
						_this.handleControl('showTextEdit')
					}
					_this.curEditType = 3
				}
			})
			textNode.on('dragstart tap click',(e)=>{
				e.cancelBubble = true ;
				if(_this.cSwitch){
					_this.stage.draggable(false)
				}
				if(_this.curId != textNode.getId()){
					_this.handleView.setAttrs({
						rotation:textNode.rotation(),
						offsetX:0,
						offsetY:0,
						x:textNode.x(),
						y:textNode.y(),
						width:textNode.width(),
						height:textNode.height(),
					})
					console.log('cs---------');
					if(_this.curNode)_this.curNode.draggable(false)
					_this.curNode = textNode;
					textNode.draggable(true)
					_this.handleView.moveToTop()
					tr.moveToTop()
					_this.curId = textNode.getId()
					if(_this.cur){
						_this.cur.hide()
					}
					_this.cur = tr
					_this.cur.show()
					layer.add(tr);
					layer.batchDraw();
					if(_this.isAdmin){
						_this.handleControl('editText',{item:textNode,index:option.id})
						_this.curEditType = 3
					}
				}
			})
			textNode.on('dragmove',()=>{
				if(!isToHistory){
					isToHistory = true
				}
			})
			textNode.on('dragend', () => {
				_this.handleView.to({
					x:textNode.x(),
					y:textNode.y(),
					width:textNode.width(),
					height:textNode.height(),
					duration:0,
				})
				if(isToHistory){
					_this.setHistory(textNode.attrs)
					isToHistory = false
				}
			})
		}
		if(option.transfrom　!== false){
			textNode.on('transform', function() {
				// console.log('transform')
				// reset scale, so only with is changing by transformer
				textNode.setAttrs({
					width: textNode.width() * textNode.scaleX(),
					height: textNode.height() * textNode.scaleY(),
					scaleX: 1,
					scaleY: 1,
				});
				_this.layer.batchDraw()
			});
			textNode.on('transformend', function() {
				console.log('transform')
				textNode.height('auto')
				_this.handleView.rotation(textNode.rotation())
				_this.handleView.height(textNode.height())
				_this.handleView.x(textNode.x())
				_this.handleView.y(textNode.y())
				_this.handleView.width(textNode.width())
				// reset scale, so only with is changing by transformer
				console.log(textNode.attrs);
				_this.setHistory(textNode.attrs)
				_this.layer.batchDraw()
			});
		}
		if(option.edit || _this.isAdmin){
			textNodeEdit({current:textNode,tr,layer,stage:this.stage},_this)
		}
		if(option.uniline){
			console.log(option.uniline,option.text);
			// textNode.width('auto');
		}
		// textNode.height('auto')
		layer.add(textNode);
		textNode.zIndex(option.index)
		if(option.isAdd)textNode.moveToTop()
		layer.batchDraw();
		_this.setHistory(textNode.attrs,option.isAdd?0:1)
		_this.$set(_this.objList,option.id,textNode)
		// _this.objList[option.id] = textNode
		_this.trList[option.id] = tr;
		callback({current:textNode,tr})
	}
	
	loadImage(option, layer, callback = () => {}){
		return new Promise((resolve,rej)=>{
			try{
				// this.filterNumberInObject(option)
				let id = Date.now()
				option._src = option.src.indexOf('http') == 0? option.src:'';
				if(option.src.search('http') == 0){
					console.log('图片下载');
					// 下载文件,进行缓存,可以优化文件加载速度,也可以防止ios跨域问题
					let result;
					uni.getEnv(async (res)=>{
						if(res.plus && true){
							try{
								let src = ''
								src = await downloadFile({fileUrl:option.src})
								// 兼容IOS,IOS的img标签无法直接写入本地地址,需要转成base64,anroid无此bug
								plus.io.resolveLocalFileSystemURL(src, (entry)=>{  
									console.log('转换链接');
									entry.file((path)=>{  
										getBase64(path, src,async (src,result)=>{
											// console.log(result);
											result =await this.editImage({...option,src:result,_src:option.src}, layer, callback)
											resolve(result)
										});
									})  
								}); 
								// plus.storage.setItem(option.src, src);
							}catch(e){
								//TODO handle the exception
								console.log(e);
								result =await this.editImage(option, layer, callback)
								resolve(result)
							}
							
						}else{
							result =await this.editImage(option, layer, callback)
							resolve(result)
						}
					});
					
				}else{
					this.editImage(option, layer, callback)
				}
			}catch(e){
				rej(e)
				//TODO handle the exception
			}
		})
		
		
	}
	
	editImage(option, layer, callback){
		return new Promise((res,rej)=>{
			let imageObj = new Image();
			const _this = this.$this
			let tr = null;
			let isToHistory = false;  //是否记录
			if (option.constructor.name == 'String') {
				let src = option
				option = {}
				option.src = src
			}
			option.type = 'image'
			if(!window.plus && option.src.indexOf('http') == 0){
				option.src = option.src+'?'+Math.random()*10000;
			}
			Konva.Image.fromURL(option.src, (image)=>{
				console.log('新的');
				image.setAttrs({
					offsetX:option.width/2,
					offsetY:option.height/2,
					...option,
					x:(option.x+option.width/2),
					y:(option.y+option.height/2)
				})
				image.attrs.rotation = image.rotation()
				image.attrs.scaleY = image.scaleY()
				image.attrs.scaleX = image.scaleX()
				image.image().setAttribute('id',option.id)
				if(option.isDraggable){
					image.hitFunc(function(context) {
					  context.beginPath();
					  context.rect(0, 0, image.width(), image.height());
					  context.closePath();
					  context.fillStrokeShape(image);
					});
					/* let hammertime = new Hammer(image, {
						domEvents: true
					});
					hammertime.get('rotate').set({
						enable: true
					});
					let oldRotation = 0;
					let startScale = 0;
					image.on('rotatestart', function(ev) {
						oldRotation = ev.evt.gesture.rotation;
						startScale = image.scaleX();
						image.stopDrag();
						image.draggable(false);
					});
					
					image.on('rotate', function(ev) {
						var delta = oldRotation - ev.evt.gesture.rotation;
						image.rotate(-delta);
						oldRotation = ev.evt.gesture.rotation;
						image.scaleX(startScale * ev.evt.gesture.scale);
						image.scaleY(startScale * ev.evt.gesture.scale);
						layer.batchDraw();
					});
					
					image.on('rotateend rotatecancel', function(ev) {
						image.draggable(true);
						layer.batchDraw();
					}); */
				}else{
					image.hitFunc(function(context) {
					  context.beginPath();
					  context.rect(0, 0, 0, 0);
					  context.closePath();
					  // important Konva method that fill and stroke shape from its properties
					  context.fillStrokeShape(image);
					});
				}
				
				if(!_this.historyImgList[option.id]){
					_this.historyImgList[option.id] = []
					image.attrs.imgIndex = -1;
					image.attrs.imgIndex = 0;
					_this.historyImgList[option.id][image.attrs.imgIndex] = {id:option.id,src:option.src,element:image.image()}
				}
				if (option.frame) {
					tr = addFrame({
						current:image,
						id:option.frame.id,
						anchorSize:20,
						rotationSnaps:[0, 90, 180, 270],
						position:option.frame.position || [],
						type:'image',
						// centeredScaling:true,
					},_this)
					image.on('tap click',async (e)=>{
						console.log('chufa');
						e.cancelBubble = true ;
						if (_this.curId == image.getId()) {
							console.log('切换图片');
							try{
								let file = new Image();
								file.id = option.id+'_'+_.uniqueId()
								let index = image.attrs.imgIndex += 1;
								let result = await this.pickPic({id:option.id,index,node:image})
								file.src = result
								file.onerror = function() {}
								file.onload = function() {
									console.log('onload');
									let i = image.width() / file.width
									image.clearCache()
									image.attrs.src = result
									image.height(file.height * i)
									image.scale({x:1,y:1})
									image.image(file);
									if(!_this.historyImgList[option.id][index]){
										_this.historyImgList[option.id][index] = {}
									}
									_this.historyImgList[option.id][index].element = file
									_this.setHistory(image.attrs)
									image.cache()
									layer.batchDraw();
								}
							}catch(e){
								console.log(JSON.stringify(e))
								console.log('切换失败');
							}
							
						}
					}) 
					image.on('dragstart tap click',(e)=>{
						console.log('chufa');
						// _this.stage.draggable(false)
						e.cancelBubble = true ;
						if (_this.curId != image.getId()) {
							if(_this.cSwitch){
								_this.stage.draggable(false)
							}
							_this.handleView.to({
								rotation:image.rotation(),
								offsetX:image.offsetX(),
								offsetY:image.offsetY(),
								scaleX:image.scaleX(),
								scaleY:image.scaleY(),
								x:image.x(),
								y:image.y(),
								width:image.width(),
								height:image.height(),
								duration:0,
							})
							console.log(_this.handleView.getAttrs());
							console.log(image.getAttrs());
							if(_this.curNode)_this.curNode.draggable(false)
							// _this.stage.draggable(false)
							_this.curNode = image;
							image.draggable(true)
							_this.handleView.moveToTop()
							tr.moveToTop()
							console.log(tr);
							tr.forceUpdate()
							_this.curId = image.getId()
							if (_this.cur) {
								_this.cur.hide()
							}
							_this.cur = tr
							_this.cur.move
							_this.cur.show()
							layer.add(tr);
							layer.batchDraw();
						}
					})
					image.on('dragmove',(e)=>{
						e.cancelBubble = true ;
						if(!isToHistory){
							isToHistory = true
						}
					})
					image.on('dragend', () => {
						console.log(image.width());
						console.log(image.scale());
						_this.handleView.to({
							offsetX:image.width()/2,
							offsetY:image.height()/2,
							x:image.x(),
							y:image.y(),
							scaleX:image.scaleX(),
							scaleY:image.scaleY(),
							width:image.width(),
							height:image.height(),
							duration:0,
						})
						// _this.handleView.scale(image.scale())
						console.log(_this.handleView.scaleX());
						if(isToHistory){
							_this.setHistory(image.attrs)
							isToHistory = false
						}
					})
				}
				if(option.transfrom　!== false){
					image.on('transformend', function() {
						console.log('transform')
						_this.handleView.rotation(image.rotation())
						_this.handleView.height(image.height())
						_this.handleView.scale(image.scale())
						_this.handleView.x(image.x())
						_this.handleView.y(image.y())
						_this.handleView.width(image.width())
						_this.layer.batchDraw()
						_this.setHistory(image.attrs)
					});
				}
				image.cache()
				layer.add(image);
				image.zIndex(option.index)
				layer.batchDraw();
				if(!_this.historyDate[option.id]){
					_this.historyDate[option.id] = []
				}
				let obj = JSON.parse(JSON.stringify(image.attrs))
				_this.historyDate[option.id].push(obj)
				if(option.isAdd){
					image.moveToTop()
					image.attrs.index = image.zIndex()
					_this.setHistory(image.attrs,option.isAdd?0:1)
				}
				_this.$set(_this.objList,option.id,image)
				// _this.objList[option.id] = image;
				_this.trList[option.id] = tr;
				callback({current:image,tr:tr})
				console.log('加载成功1');
				res({current:image,tr:tr})
			});
			// imageObj.onerror = function(e) {}
			// imageObj.src = option.src
		})
		
	}
	
	save({stage,type = 'img',id},_this){
		return new Promise((resolve,reject)=>{
			if(type == 'img'){
				let sX = _this.stage.x()
				let sY = _this.stage.y()
				let num = (_this.stageW / (_this.stageW * _this.scale)).toFixed(3)-0+0.001
				if(_this.isAdmin){
					num = (_this.stageW / (_this.stageW * _this.scale)).toFixed(5)-0+0.00001
				}
				console.log('偏移：',sX,sY);
				console.log('宽高：',_this.stageW,_this.stageH);
				let node = null;
				if(!_this.isAdmin){
					node = _this.layer.findOne('#watermark')
					console.log(_this.is_vip);
					if(_this.is_vip != 1){
						node.show();
						_this.layer.batchDraw()
					}
				}
				
				var dataURL = stage.toDataURL({ pixelRatio: num,mimeType:'image/jpeg',quality:1,x:sX,y:sY,width:_this.stageW*_this.scale,height:_this.stageH*_this.scale });
				console.log(_this.scale);
				if(!_this.isAdmin){
					if(_this.is_vip != 1){
						node.hide();
						_this.layer.batchDraw()
					}
				}
				let arr = []
				_this.layer.find((item,index)=>{
					let obj = JSON.parse(JSON.stringify(item.attrs))
					let res = JSON.parse(JSON.stringify(obj))
					if(obj.type === 'text' && !obj.hideEle){
						res = this.filterNumberInObject(res,['x', 'y', 'fontSize','width','letterSpacing'],num)
						console.log(res.text,res.width);
						res.fontFamily = item.fontFamily()
						if(item.width !== 'auto'){
							if(item.height() < (item.fontSize()*1.5) && res.align == 'left'){
								console.log('单行文字');
								item.width('auto')
								res.width = 'auto'
							}
						}
						if(res.width !== 'auto'){
							delete res.uniline
						}
						console.log(res.text,res.width);
						res.wrap = 'char'
						delete res.unline
					}
					if(obj.type === 'rect' && !obj.hideEle){
						res.width = item.width()
						res = this.filterNumberInObject(res,'',num)
					}
					if(obj.type === 'image' && !obj.hideEle){
						if(res.offsetX)res.x=~~(res.x - res.offsetX)
						if(res.offsetY)res.y=~~(res.y-res.offsetY);
						res = this.filterNumberInObject(res,null,num)
						let src = ''
						if( res.src || res._src ){
							src = res.src.indexOf('http') === 0?res.src:res._src.indexOf('http') === 0?res._src:_this.historyImgList[res.id][res.imgIndex].url
						}
						res.src = src?src:res.src;
						res.src = res.src.split('?')[0]
						delete res.image
						delete res._src
						delete res.offsetX
						delete res.offsetY
					}
					delete res.isAdd
					delete res.lock
					if(res.id !== 'temp' && res.type !== 'tr' && res.type && res.id !== 'watermark' && !res.hideEle){
						res.index = item.zIndex()
						console.log(res.text);
						console.log(res);
						res.id = item._id+''
						arr.push(res)	
					}
				})
				console.log(arr);
				console.log(JSON.stringify(arr));
				
				// console.log(dataURL);
				id = id || Date.now()
				uni.getEnv((res)=>{
					if(res.plus){
						var bitmap = new plus.nativeObj.Bitmap(`bitmap${id}`);
						bitmap.loadBase64Data(dataURL,function(){
							console.log('加载图片成功');
							bitmap.save( `_doc/uniapp_temp/canvas/${id}.jpg`,{overwrite:true,format:'jpg',quality:100},function(i){
								bitmap.clear()
								resolve({image:`_doc/uniapp_temp/canvas/${id}.jpg`,data:arr})
								console.log('保存图片成功');
								/* plus.gallery.save( `_doc/uniapp_temp/canvas/${id}.jpg`, function () {
									plus.nativeUI.toast("保存图片到相册成功");
								}); */
							},function(e){ 
								bitmap.clear()
								reject('保存图片失败：'+JSON.stringify(e))
								toast('保存图片失败：'+JSON.stringify(e)); 
							});
						},function(e){ 
							bitmap.clear()
							reject('加载图片失败：'+JSON.stringify(e))
							toast('加载图片失败：'+JSON.stringify(e));
						});
					}else{
						if(!_this.isAdmin){
							resolve({image:dataURL,data:arr})
						}else{
							
							/* var link = document.createElement('a');
							link.download = id;
							link.href = dataURL;
							document.body.appendChild(link);
							link.click();
							document.body.removeChild(link); */
							resolve({image:dataURL,data:arr})
						}
						
					}
				});
			}else if(type == 'json'){
				return resolve(stage.toJSON())
			}else{
				toast('暂无更多保存类型');
				return reject('暂无更多保存类型')
			}
		})
		
	}
	
	dataURLtoFile(dataurl, filename) {//将base64转换为文件
	    var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
	    bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
		console.log(mime);
	    while(n--){
	        u8arr[n] = bstr.charCodeAt(n);
	    }
	    return new File([u8arr], filename, {type:mime});
	}
	
	filterNumberInObject(option,rules,num){
		let rule = ['x','y','width','height']
		let isText = option.type === 'text'?true:false;
		if(isText){
			option.letterSpacing = ~~option.letterSpacing || 0
 			option.lineHeight = parseFloat(option.lineHeight) || 1
			option.rotation = ~~option.rotation || 0
			option.wrap = 'char'
		}
		delete option.visible
		rule = rules?rules:rule
		_.map(option,(item,index)=>{
			if(rule.indexOf(index) === -1)return;
			if(typeof (item-0) === 'number' && !isNaN((item-0))){
				// console.log(index,option.text,option.width);
				if(num){
					if(index === 'lineHeight'){
						// option[index] =  parseFloat(parseFloat(item * num).toFixed(1))
					}else{
						option[index] =  parseFloat(item * num).toFixed(2)
					}
				}else{
					if(index === 'lineHeight'){
						// option[index] =  parseFloat(parseFloat(item * this.$this.scale).toFixed(1))
					}else{
						option[index] =  parseFloat(item * this.$this.scale)
					}
				}
			}
		})
		if(isText){
			option.width = option.width?option.width:'auto'
		}
		// console.log(option);
		return option
	}
	
	pickPic(option){
		return new Promise(async (res,rej)=>{
			const _this = this.$this
			const __this = this
			const layer = _this.layer
			if(_this.env === 'plus'){
				plus.gallery.pick( function(path){
				   	console.log(path);
					getBase64(path, '',async (src,result)=>{
						let serverTime  = Math.floor(new Date()/1000)
						let rT = serverTime
						var task=plus.uploader.createUpload(_this.http+'/user/upload_img',
							{method:"POST"},
							function(t,status){ //上传完成
								console.log(status);
								console.log(t.responseText);
								if(status==200){
									let r = JSON.parse(t.responseText)
									console.log(r);
									console.log(r.code);
									if(r.code == 0){
										let index = option.index
										let id = option.id
										console.log(index);
										console.log('上传成功');
										if(option.node){
											option.node.attrs.src =  r.data
										}else{
											let node = _this.layer.find('#'+option.id)[0]
											if(node)node.attrs.src = r.data;
										}
										if(!_this.historyImgList[option.id]){
											_this.historyImgList[option.id] = []
											index = 0;
											_this.historyImgList[option.id][index] = {}
										}
										if(!_this.historyImgList[option.id][index])_this.historyImgList[option.id][index] = {}
										_this.historyImgList[option.id][index].id = id
										_this.historyImgList[option.id][index].url = r.data
										console.log(_this.historyImgList[option.id][index].url);
									}
								}else{
									console.log('上传失败');
								}
							}
						);
						task.setRequestHeader( "Secret",_md5({
							folder:'poster',
							file:path
						}));
						task.setRequestHeader( "Db-Token", _this.token || '');
						task.setRequestHeader( "Version-Number", _this.version+'' || '1');
						task.setRequestHeader( "Timestamp", rT+'');
						task.addData('folder', 'poster');
						task.addData('wniu', 1);
						task.addFile(path,{key:'file'});
						task.start();
						res(result)
					});
					// file.crossOrigin = "Anonymous"
				}, function ( e ) {
					rej(e)
					console.log( "取消选择图片" );
				}, {filter:"image"} );
			}else{
				console.log('进入');
				let random = _.uniqueId()
				if(option.file){
					try{
						let result  = await __this.handleUpdataImg(option.file,option,random)
						res(result)
					}catch(e){
						rej(e)
						//TODO handle the exception
					}
				}else{
					let fileInput = $('<input id="imgInput'+random+'" type="file" accept="image/*" style="opacity:0" />')
					$('body').append(fileInput)
					$(fileInput).click()
					$(fileInput).change(async function(){
						if (this.files && this.files[0]) {
							try{
								let result  = await __this.handleUpdataImg(this.files[0],option,random)
								res(result)
							}catch(e){
								rej(e)
								//TODO handle the exception
							}
						}
					})
					console.log(fileInput);
				}
			}
		})
	}
	handleUpdataImg(file,option,random){
		console.log('handleUpdataImg');
		return new Promise((res,rej)=>{
			const _this = this.$this
			var data = new FormData();
			data.append('file', file);
			data.append('folder', 'poster');
			setTimeout(function(){
				// 图片上传功能
				if(_this.isAdmin && true){
					request_post({
						url:_this.isAdmin && O ? '/addons/alioss/index/upload' : '/user/upload_img',
						isFile:true,
						data:data,
						success:(res)=>{
							let index = option.index
							let id = option.id
							console.log(index);
							console.log('上传成功');
							console.log(res);
							if(option.node){
								option.node.attrs.src = _this.isAdmin && O?res.data.url: res.data
							}else{
								let node = _this.layer.find('#'+option.id)[0]
								console.log(node);
								if(node)node.attrs.src = _this.isAdmin && O?res.data.url: res.data;
							}
							if(!_this.historyImgList[option.id]){
								_this.historyImgList[option.id] = []
								index = 0;
								_this.historyImgList[option.id][index] = {}
							}
							if(!_this.historyImgList[option.id][index])_this.historyImgList[option.id][index] = {}
							_this.historyImgList[option.id][index].id = id
							_this.historyImgList[option.id][index].url = _this.isAdmin && O?res.data.url: res.data
						}
					},_this)
				}
				
			},1000)
			const reader = new FileReader();
			reader.readAsDataURL(file);
			reader.onload = (e) => {
				if(random)$('#imgInput'+random).remove()
				res(e.target.result)
			};
			reader.onerror = (e) => {
				rej(e)
			};
		})
	}
}
